#include <sc/sc.h> // system core //
#include <sc/sc_config.h>
#include <sc/sys_core.h>

#include "at91rm9200_tc.h"
/**
   \brief Writes a timer / counter register.
   \param iReg - register (offset)
   \param iValue - value to write
   \param iBlock - 0 for block0 / 1 for block 1
*/

static inline void at91_tc1_write(unsigned int iBlock, unsigned int iReg, unsigned long iValue)
  {
    unsigned int pBase = (unsigned int)AT91C_BASE_TCB0;
    if (iBlock)
      pBase = (unsigned int)AT91C_BASE_TCB1;
    mcu_write32(pBase+iReg, iValue);
  }

#if 0
void blinkAB(unsigned int iA, unsigned int iB)
  {
    AT91S_SYS* pSys = (AT91S_SYS*)AT91C_BASE_SYS;
            
    int boEnable = ((iA != 0) || (iB != 0));
//    std::cerr << "Was: " << boWasEnable << std::endl;
    if (boEnable)
      {
        unsigned int A = 0;
        unsigned int B = 0x40;
        

//        if (!(boWasEnable))
          {
            pSys->PMC_PCER = (1 << AT91C_ID_TC3) | (1 << AT91C_ID_TC4);

            if (iA)
              at91_tc1_write(1, AT91_TC_CMR+(A),     AT91_TC_WAVESEL | AT91_TC_ASWTRG_CLEAR | AT91_TC_WAVE  | AT91_TC_ACPA_SET | AT91_TC_TIMER_CLOCK5 | AT91_TC_ACPC_CLEAR | AT91_TC_WAVESEL_UPDOWN);

            if (iB)
              at91_tc1_write(1, AT91_TC_CMR+(B),     AT91_TC_WAVESEL | AT91_TC_ASWTRG_CLEAR | AT91_TC_WAVE  | AT91_TC_ACPA_SET | AT91_TC_TIMER_CLOCK5 | AT91_TC_ACPC_CLEAR | AT91_TC_WAVESEL_UPDOWN);
          }

        unsigned int iDiv1 = iA*32;
        at91_tc1_write(1, AT91_TC_RA+(A), 0);
        at91_tc1_write(1, AT91_TC_RC+(A), iDiv1);

        
        unsigned int iDiv2 = iB*32;
        at91_tc1_write(1, AT91_TC_RA+(B), 0);
        at91_tc1_write(1, AT91_TC_RC+(B), iDiv2);
        
//        if (!(boWasEnable))
          {
            at91_tc1_write(1, AT91_TC_CCR+(A), AT91_TC_CLKEN);
            at91_tc1_write(1, AT91_TC_CCR+(A), AT91_TC_SWTRG);
            
            at91_tc1_write(1, AT91_TC_CCR+(B), AT91_TC_CLKEN);
            at91_tc1_write(1, AT91_TC_CCR+(B), AT91_TC_SWTRG);

            // Turn on peripheral pins...
            pSys->PIOB_BSR = (1 << 6); // (1 / TIOA3)
            pSys->PIOB_PDR = (1 << 6);
            pSys->PIOB_OER = (1 << 6);
            
            pSys->PIOB_BSR = (1 << 8); // (1 / TIOA4)
            pSys->PIOB_PDR = (1 << 8);
            pSys->PIOB_OER = (1 << 8);
          }
      }
    else
      {
        pSys->PMC_PCDR = (1 << AT91C_ID_TC3) | (1 << AT91C_ID_TC4);
        
        pSys->PIOB_PER = (1 << 6);
        pSys->PIOB_OER = (1 << 6);
        pSys->PIOB_CODR = (1 << 6);

        pSys->PIOB_PER = (1 << 8);
        pSys->PIOB_OER = (1 << 8);
        pSys->PIOB_CODR = (1 << 8);
      }
  }

#else
void blinkPB6(unsigned int iA)
  {
    AT91S_SYS* pSys = (AT91S_SYS*)AT91C_BASE_SYS;
    int boEnable = (iA != 0);
    if (boEnable)
      {
        unsigned int A = 0;
        
          {
            pSys->PMC_PCER = ((1 << AT91C_ID_TC3) || (1 << AT91C_ID_TC4));

            if (iA)
              at91_tc1_write(1, AT91_TC_CMR+(A),     AT91_TC_WAVESEL | AT91_TC_ASWTRG_CLEAR | AT91_TC_WAVE  | AT91_TC_ACPA_SET | AT91_TC_TIMER_CLOCK5 | AT91_TC_ACPC_CLEAR | AT91_TC_WAVESEL_UPDOWN);
          }

        unsigned int iDiv1 = iA*32;
//        at91_tc1_write(1, AT91_TC_BMR+(A), 0);
        at91_tc1_write(1, AT91_TC_RA+(A), 0);
        at91_tc1_write(1, AT91_TC_RC+(A), iDiv1);

        
        at91_tc1_write(1, AT91_TC_CCR+(A), AT91_TC_CLKEN);
        at91_tc1_write(1, AT91_TC_CCR+(A), AT91_TC_SWTRG);

        // Turn on peripheral pins...
        pSys->PIOB_BSR = (1 << 6); // (1 / TIOA3)
        pSys->PIOB_PDR = (1 << 6);
        pSys->PIOB_OER = (1 << 6);
      }
    else
      {
        pSys->PMC_PCDR = (1 << AT91C_ID_TC3);
        
        pSys->PIOB_PER = (1 << 6);
        pSys->PIOB_OER = (1 << 6);
        pSys->PIOB_CODR = (1 << 6);
      }
  }
#endif
