/**
 *
 * Copyright (c) 2005 Conitec Datasystems GmbH
 * Written 2005 by Peer Georgi <georgi@conitec.com>
 *
 * License: GPL
 *
 * This program is free software; you may redistribute and/or modify it under
 * the terms of the GNU General Public License Version 2 as published by the
 * Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY, without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
 * for complete details.
 **
*/


#ifndef __cLDBA_h
  #define __cLDBA_h

#include <at/include/at91rm9200-def.h>
    
typedef struct cLDBA
  {
  // << public >> //

  /// this is the udp callback the pointer will be valid after construction
    char (*handleUDPRequest)(void* pObject, AT91PS_UDP pUDP, unsigned short iReq, unsigned short wValue, unsigned short wLength);
  
  // << private >> //
  /// data to process //
    char mpCmdBuffer[2048];
  /// number of command; will cleared by dispatcher after execution //
    unsigned short miCurrentCmd;
  /// size of current cmd //
    unsigned short miCurrentCmdSize;
    
  /// current memory store address pointer (relative to SDRAM start)
    unsigned int miCurrentStoreAddress;
  } cLDBA_;

extern void ldba_construct(struct cLDBA* pLDBA);
extern char ldba_poll(struct cLDBA* pLDBA);

#define LDBA_CMD_TRANSFER_IN_PROGRESS    (1 << 15)   // if this bit is set, the cmd is NOT ready to execute //

#define LDBA_CMD_CHECK_READY             0x001
#define LDBA_CMD_SET_ADDRESS             0x002
#define LDBA_CMD_STORE                   0x003
#define LDBA_CMD_EXECUTE                 0x004
#define LDBA_CMD_NOTE                    0x005
#define LDBA_HANGUP                      0xfff

#endif // __cLDBA_h
