/**
 *
 * Copyright (c) 2005 Conitec Datasystems GmbH
 * Written 2005 by Peer Georgi <georgi@conitec.com>
 *
 * License: GPL
 *
 * This program is free software; you may redistribute and/or modify it under
 * the terms of the GNU General Public License Version 2 as published by the
 * Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY, without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
 * for complete details.
 **
*/


#ifndef __sc_UDP_h
  #define __sc_UDP_h

#include <at/include/at91rm9200-def.h>

/**
  Module provides a control endpoint (EP0).
*/
  
/**
  Initialize UDP hardware.
*/
void sc_udp_init();

extern void sc_udp_done();

/**
  Perform USB reset.
*/
extern void sc_udp_resetBUS(void);

/**
  Keep communication.
*/
void sc_udp_poll(void* _pObject, char (*pOwnDispatcher)(void* _pObject, AT91PS_UDP pUDP, unsigned short iReq, unsigned short wValue, unsigned short wLength));

/// debug support
void __sc_udp_debug_printRegs();

extern void __sc_udp_sendStall(AT91PS_UDP pUDP);
extern void __sc_udp_sendZLP(AT91PS_UDP pUDP);
void __sc_udp_readData(AT91PS_UDP pUDP, char* pTarget, unsigned int iLength);

#endif // __sc_UDP_h
