
#define LED_BOOT                        (1 << 20)
#define LED1                            (1 << 20)
#define LED2                            (1 << 23)
#define LED3                            (1 << 25)


extern void AT91F_PIO_ClearOutput(AT91PS_PIO p, unsigned int i);
extern void AT91F_PIO_SetOutput(AT91PS_PIO p, unsigned int i);
extern void AT91F_PIO_CfgOutput(AT91PS_PIO p, unsigned int i);
extern unsigned int AT91F_PIO_GetInput(AT91PS_PIO pPio);

/**
  Will be called to initialize the boot-progress notifier.
*/
void bootLEDInit()
  {
    // setup led outputs //
#if 0
    AT91C_BASE_PIOD->PIO_SODR = LED1;
    AT91C_BASE_PIOD->PIO_SODR = LED2;
    AT91C_BASE_PIOD->PIO_SODR = LED3;

    AT91C_BASE_PIOD->PIO_OER = LED1;
    AT91C_BASE_PIOD->PIO_OER = LED2;
    AT91C_BASE_PIOD->PIO_OER = LED3;
    /
    / turn on boot-led //
    AT91C_BASE_PIOD->PIO_CODR = LED_BOOT;
#endif

    blinkPB6(100);
  }

void bootLEDShowProgress()
  {
      // toggle U3 //
     if (AT91F_PIO_GetInput(AT91C_BASE_PIOD) & (LED2))
       AT91F_PIO_ClearOutput(AT91C_BASE_PIOD, LED2);
     else
       AT91F_PIO_SetOutput(AT91C_BASE_PIOD, LED2);
  }


/**
  Will be called before the first application will be executed.
*/
void bootLEDCleanUp()
  {
    // show red light...
    AT91C_BASE_PIOB->PIO_PER = (1 << 6);
    AT91C_BASE_PIOB->PIO_SODR = (1 << 6);
    AT91C_BASE_PIOB->PIO_OER = (1 << 6);

    AT91F_PIO_ClearOutput(AT91C_BASE_PIOD, LED2);
    AT91F_PIO_SetOutput(AT91C_BASE_PIOD, LED1);
  }
