/**
 * Copyright (c) 2005 Peer Georgi <peer@peer-ware.de>
 * License: GPL
 *
 * This program is free software; you may redistribute and/or modify it under
 * the terms of the GNU General Public License Version 2 as published by the
 * Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY, without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for complete details.
*/


#include "cAbstractNetDevice.h"
#include "cNetProtocolMgr.h"

cAbstractNetDevice::cAbstractNetDevice()
  : mpProtocolMgr(0)
    { }

cAbstractNetDevice::~cAbstractNetDevice() throw()
  {
  }

bool cAbstractNetDevice::send(char* pFrame, unsigned int iSize)
  {
    return (false);
  }

extern "C"
  { 
    #include <sc/sc.h>
  }

void cAbstractNetDevice::notifyProtocolParam(const cNetAbstractProtocolParam&)
  {
    // we do nothing here (abstract device) //
  }
  
void cAbstractNetDevice::dispatchReceived(char* pFrame, unsigned int iSize)
  {
    if (mpProtocolMgr)
      mpProtocolMgr->dispatchFrame(pFrame, iSize);
  }

void cAbstractNetDevice::linkProtocolMgr(cNetProtocolMgr* p)
  {
    mpProtocolMgr = p;
  }

cNetProtocolMgr* cAbstractNetDevice::getProtocolMgr() const
  {
    return (mpProtocolMgr);
  }
