/**
 * Copyright (c) 2005 Peer Georgi <peer@peer-ware.de>
 * License: GPL
 *
 * This program is free software; you may redistribute and/or modify it under
 * the terms of the GNU General Public License Version 2 as published by the
 * Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY, without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for complete details.
*/


#ifndef __cAbstractNetDevice_h
  #define __cAbstractNetDevice_h

class cNetProtocolMgr;
class cNetAbstractProtocolParam;

class cAbstractNetDevice
  {
  friend class cNetProtocolMgr;
  public:
    cAbstractNetDevice();
    virtual ~cAbstractNetDevice() throw();

    virtual bool send(char* pFrame, unsigned int iSize);
    virtual void notifyProtocolParam(const cNetAbstractProtocolParam&);
  
  protected:
    void dispatchReceived(char* pFrame, unsigned int iSize);
    void linkProtocolMgr(cNetProtocolMgr*);
    cNetProtocolMgr* getProtocolMgr() const;
     
  private:
    cNetProtocolMgr* mpProtocolMgr;
  };


#endif // __cAbstractNetDevice_h
