/**
 * Copyright (c) 2005 Peer Georgi <peer@peer-ware.de>
 * License: GPL
 *
 * This program is free software; you may redistribute and/or modify it under
 * the terms of the GNU General Public License Version 2 as published by the
 * Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY, without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for complete details.
*/


#include "cNetIPv4Address.h"
#include "console.h"
extern "C"
  {
    #include <sc/sc.h>
  }


cNetIPv4Address::cNetIPv4Address()
  : miAddress(0)
  { }

cNetIPv4Address::cNetIPv4Address(unsigned int iAddres)
  : miAddress(iAddres)
  { }

cNetIPv4Address::~cNetIPv4Address() throw()
  { }


unsigned int cNetIPv4Address::load(char* p)
  {
    unsigned int iAddr = 0;
    for (unsigned int i = 0; i < 4; i++)
      {
        iAddr |= (unsigned int)p[3-i];
        if (i != 3)
          iAddr <<= 8;
      }
    miAddress = iAddr;
    return (iAddr);
  }

void cNetIPv4Address::store(char* p) const
  {
    unsigned int iIPAddr = miAddress;
    for (unsigned int i = 0; i < 4; i++)
      {
        p[i] = iIPAddr & 255;
        iIPAddr >>= 8;
      }
  }

void cNetIPv4Address::debugPrint() const
  {
    bool boDelim = false;
    for (unsigned int i = 0; i < 4; i++)
      {
        if (boDelim)
          scDbg(".");
        unsigned int iToken = (miAddress >> (i << 3)) & 255;
        scDbgPrintDec(iToken);
        boDelim = true;
      }
  }

bool cNetIPv4Address::operator==(const cNetIPv4Address& with) const
  {
    return (with.miAddress == miAddress);
  }

bool cNetIPv4Address::operator!=(const cNetIPv4Address& with) const
  {
    return (!((*this) == with));
  }
