/**
 * Copyright (c) 2005 Peer Georgi <peer@peer-ware.de>
 * License: GPL
 *
 * This program is free software; you may redistribute and/or modify it under
 * the terms of the GNU General Public License Version 2 as published by the
 * Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY, without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for complete details.
*/


#include "cNetIPv4ProtocolPEParam.h"
#include "cNetProtocolID.h"

cNetIPv4ProtocolPEParam::cNetIPv4ProtocolPEParam(const cNetIPv4Address& address, unsigned short iProtocol)
  : cNetAbstractPEParam(), mAddress(address), miProtocol(iProtocol)
    {
    }

cNetIPv4ProtocolPEParam::~cNetIPv4ProtocolPEParam() throw()
  {
  }

unsigned int cNetIPv4ProtocolPEParam::getID() const
  {
    return (NET_PROTOCOL_ID_IPV4);
  }

const cNetIPv4Address& cNetIPv4ProtocolPEParam::getAddress() const
  {
    return (mAddress);
  }

unsigned short cNetIPv4ProtocolPEParam::getProtocol() const
  {
    return (miProtocol);
  }
