/**
 * Copyright (c) 2005 Peer Georgi <peer@peer-ware.de>
 * License: GPL
 *
 * This program is free software; you may redistribute and/or modify it under
 * the terms of the GNU General Public License Version 2 as published by the
 * Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY, without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for complete details.
*/


#ifndef __cNetIPv4ProtocolPEParam_h
  #define __cNetIPv4ProtocolPEParam_h

#include "cNetAbstractPEParam.h"
#include "cNetIPv4Address.h"
/**
  It needs a IPv4 receiver address.
*/
class cNetIPv4ProtocolPEParam : public cNetAbstractPEParam
  {
  public:
    cNetIPv4ProtocolPEParam(const cNetIPv4Address&, unsigned short iProtocol);
    virtual ~cNetIPv4ProtocolPEParam() throw();

    virtual unsigned int getID() const;
    const cNetIPv4Address& getAddress() const;
    unsigned short getProtocol() const;
    
  private:
    cNetIPv4Address mAddress;
    unsigned short miProtocol;
  };

#endif // __cNetIPv4ProtocolPEParam_h
