/**
 * Copyright (c) 2005 Peer Georgi <peer@peer-ware.de>
 * License: GPL
 *
 * This program is free software; you may redistribute and/or modify it under
 * the terms of the GNU General Public License Version 2 as published by the
 * Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY, without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for complete details.
*/


#ifndef __cNetMACAddress_h
  #define __cNetMACAddress_h

class cNetMACAddress
  {
  public:
    cNetMACAddress();
    cNetMACAddress(char*, unsigned int iSize);
    ~cNetMACAddress() throw();

    void debugPrint() const;
    void store(char*) const;
    char* load(char*, unsigned int iSize);
    bool readFromString(const char* s, unsigned int iLen);
    void setOctet(unsigned int iIdx, char bValue);
    char getOctet(unsigned int iIdx) const;
    const char* getAddress() const;
    unsigned int getSize() const;

    bool operator==(const cNetMACAddress&) const;
    bool operator!=(const cNetMACAddress&) const;

  private:
    enum NumberConversionStatus { NCSSuccess, NCSOutOfBuffer, NCSInvalidCharacter };
    unsigned int getHexValue8(const char* p, unsigned int& iBufferBytesLeft, NumberConversionStatus&);
    
  private:
    char msMACAddress[6];
  };

#endif // __cNetMACAddress_h
