/**
 * Copyright (c) 2005 Peer Georgi <peer@peer-ware.de>
 * License: GPL
 *
 * This program is free software; you may redistribute and/or modify it under
 * the terms of the GNU General Public License Version 2 as published by the
 * Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY, without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for complete details.
*/


#include "cNetMACProtocolPEParam.h"
#include "cNetProtocolID.h"

cNetMACProtocolPEParam::cNetMACProtocolPEParam(const cNetMACAddress& macAddress)
  : cNetAbstractPEParam(), mMACAddress(macAddress)
    {
    }

cNetMACProtocolPEParam::~cNetMACProtocolPEParam() throw()
  {
  }

unsigned int cNetMACProtocolPEParam::getID() const
  {
    return (NET_PROTOCOL_ID_MAC);
  }

const cNetMACAddress& cNetMACProtocolPEParam::getMACAddress() const
  {
    return (mMACAddress);
  }
