/**
 * Copyright (c) 2005 Peer Georgi <peer@peer-ware.de>
 * License: GPL
 *
 * This program is free software; you may redistribute and/or modify it under
 * the terms of the GNU General Public License Version 2 as published by the
 * Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY, without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for complete details.
*/


#include "cNetMACProtocolParam.h"
#include "cNetProtocolID.h"

cNetMACProtocolParam::cNetMACProtocolParam()
  : cNetAbstractProtocolParam(), mMACAddress()
    {
    }


cNetMACProtocolParam::~cNetMACProtocolParam() throw()
  {
  }

unsigned int cNetMACProtocolParam::getID() const
  {
    return (NET_PROTOCOL_ID_MAC);
  }

const cNetMACAddress& cNetMACProtocolParam::getAddress() const
  {
    return (mMACAddress);
  }

void cNetMACProtocolParam::setAddress(unsigned int i, char b)
  {
    mMACAddress.setOctet(i, b);
  }

void cNetMACProtocolParam::setAddress(const cNetMACAddress& m)
  {
    mMACAddress = m;
  }

bool cNetMACProtocolParam::setAddressFromString(const char* s, unsigned int iLen)
  {
    return (mMACAddress.readFromString(s, iLen));
  }
