/**
 * Copyright (c) 2005 Peer Georgi <peer@peer-ware.de>
 * License: GPL
 *
 * This program is free software; you may redistribute and/or modify it under
 * the terms of the GNU General Public License Version 2 as published by the
 * Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY, without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for complete details.
*/


#ifndef __cNetProtoARP_h
  #define __cNetProtoARP_h

#include "cNetAbstractProtocol.h"
#include "cNetIPv4ProtocolParam.h"
#include "cNetProtoARPCache.h"
class cNetAbstractPEParam;
class cNetProtocolMgr;

class cNetProtoARP : public cNetAbstractProtocol
  {
  struct tARPFrame;
  struct tMACFrame;
  public:
    cNetProtoARP(cNetAbstractProtocol&);
    virtual ~cNetProtoARP() throw();

    virtual cNetAbstractProtocol::RxHandleState handleFrame(char*, unsigned int, char* pFullFrame = 0, unsigned int iFullSize = 0);
    virtual void notifyProtocolParam(const cNetAbstractProtocolParam&);
    virtual const cNetAbstractProtocolParam* hasProtocolParam(unsigned int iID);
    virtual void encapsulatePacket(char* pPacket, unsigned int iSize, const cNetAbstractPEParam* pParam);

  protected:
    void handleWhoHasIPv4(tARPFrame*, unsigned int iPacketSize);
  
  private:
    cNetIPv4ProtocolParam mProtocolParam;
    cNetProtoARPCache mARPCache;
  };



#endif // __cNetProtoARP_h
