/**
 * Copyright (c) 2005 Peer Georgi <peer@peer-ware.de>
 * License: GPL
 *
 * This program is free software; you may redistribute and/or modify it under
 * the terms of the GNU General Public License Version 2 as published by the
 * Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY, without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for complete details.
*/


#ifndef __cNetProtoARPCache_h
  #define __cNetProtoARPCache_h

#include "cNetIPv4Address.h"
#include "cNetMACAddress.h"

class cNetProtoARPCache
  {
  enum CacheSize { cacheSize=10 };
  public:
    cNetProtoARPCache();
    ~cNetProtoARPCache() throw();

     void addCoherence(cNetIPv4Address&, cNetMACAddress&);
     const cNetMACAddress* searchMACAddress(const cNetIPv4Address&) const;

   private:
     class cCoherencePair
       {
       public:
         cCoherencePair()
           : mIPv4Address(), mMACAddress()
           { }
           
         bool match(const cNetMACAddress& ma) const
           {
             return (ma == mMACAddress);
           }
         bool match(const cNetIPv4Address& ip) const
           {
             return (ip == mIPv4Address);
           }
       
         cNetIPv4Address mIPv4Address;
         cNetMACAddress mMACAddress;
       };
   private:
     cCoherencePair mCache[cacheSize];
     unsigned int miCurrent;
  };

#endif // __cNetProtoARPCache_h
