/**
 * Copyright (c) 2005 Peer Georgi <peer@peer-ware.de>
 * License: GPL
 *
 * This program is free software; you may redistribute and/or modify it under
 * the terms of the GNU General Public License Version 2 as published by the
 * Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY, without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for complete details.
*/


#ifndef __cNetProtoICMP_h
  #define __cNetProtoICMP_h

#include "cNetAbstractProtocol.h"
#include "cNetIPv4ProtocolParam.h"
class cNetProtocolMgr;


class cNetProtoICMP : public cNetAbstractProtocol
  {
  public:
    cNetProtoICMP(cNetAbstractProtocol&);
    virtual ~cNetProtoICMP() throw();

    virtual cNetAbstractProtocol::RxHandleState handleFrame(char*, unsigned int, char* pFullFrame = 0, unsigned int iFullSize = 0);
    virtual void notifyProtocolParam(const cNetAbstractProtocolParam&);
    virtual const cNetAbstractProtocolParam* hasProtocolParam(unsigned int iID);

  private:
    cNetIPv4ProtocolParam mProtocolParam;
  };



#endif // __cNetProtoICMP_h
