/**
 * Copyright (c) 2005 Peer Georgi <peer@peer-ware.de>
 * License: GPL
 *
 * This program is free software; you may redistribute and/or modify it under
 * the terms of the GNU General Public License Version 2 as published by the
 * Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY, without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for complete details.
*/


#ifndef __cNetProtoMAC_h
  #define __cNetProtoMAC_h

#include "cNetAbstractProtocol.h"
#include "cNetMACProtocolParam.h"
class cNetProtocolMgr;


class cNetProtoMAC : public cNetAbstractProtocol
  {
  public:
    cNetProtoMAC(cNetProtocolMgr&);
    virtual ~cNetProtoMAC() throw();

    /// True indicates that the frame was handled here //
    virtual cNetAbstractProtocol::RxHandleState handleFrame(char*, unsigned int, char* pFullFrame = 0, unsigned int iFullSize = 0);
    virtual void notifyProtocolParam(const cNetAbstractProtocolParam&);
    virtual const cNetAbstractProtocolParam* hasProtocolParam(unsigned int iID);
    virtual void encapsulatePacket(char* pPacket, unsigned int iSize, const cNetAbstractPEParam* pParam);

  private:
    cNetMACProtocolParam mMACProtocolParam;
  };



#endif // __cNetProtoMAC_h
