/**
 *
 * Copyright (c) 2005 Conitec Datasystems GmbH
 * Written 2005 by Peer Georgi <georgi@conitec.com>
 *
 * License: GPL
 *
 * This program is free software; you may redistribute and/or modify it under
 * the terms of the GNU General Public License Version 2 as published by the
 * Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY, without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
 * for complete details.
 **
*/


#ifndef __cFrontEnd_h
  #define __cFrontEnd_h

//#define CONFIG_WITH_DL_TEST

#define FE_CMD_EXECUTE_MEMORY_TEST     3
#define FE_CMD_EXECUTE_MEMORY_TEST_SR  4

#define FE_REG_MEMTEST_PATTERN         0 // testpattern for memory-test //
#define FE_REG_MEMTEST_KIND            1 // 0 = constant pattern, 1 = linear pattern test with start-pattern //


struct cFrontEnd
  {
    void (*init)(unsigned int iSDRAMSize);
    void (*poll)();
    void (*submitMemoryTestProgress)(unsigned int iAddr, char boError, unsigned int iReadOut);
    // iAddr == 0xffffffff means pattern has been set iAddr == 0xfffffffe means linear pattern test //
    void (*submitMemoryTestPatternInit)(unsigned int iPattern, unsigned int iAddr);

    // this method must set in main-application (return: 0=error, 1=ok) //
    char (*handleCmd)(unsigned int);

  // private
    /// see FE_REG_XXX constants
    unsigned int miRegs[2];
  };

extern struct cFrontEnd* getTerminalFrontEnd();

#endif // __cFrontEnd_h
