/**
 *
 * Copyright (c) 2005 Conitec Datasystems GmbH
 * Written 2005 by Peer Georgi <georgi@conitec.com>
 *
 * License: GPL
 *
 * This program is free software; you may redistribute and/or modify it under
 * the terms of the GNU General Public License Version 2 as published by the
 * Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY, without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
 * for complete details.
 **
*/


#include <sc/sc.h> // system core //
#include <string.h>
#include "cFrontEnd.h"

#define ANSI_CLRSCREEN            "\033[2J"
#define ANSI_ClEARLINE            "\033[K"

//#define INCLUDE_MEM_TEST


struct cFrontEnd gsTerminalFrontEnd;

char* gsMenuItems[] = {0, 0, "Speichertest", "Speichertest (intensiv)", "(SR)", "IO-Test (NSCX)",0,"Redraw",0,0,0,0,0,0,0,0};
unsigned int giMemTestPatterns[] = {0, 0xaaaaaaaa, 0x01020304, 0x00000000, 0xffffff,  0x12345678, 0x01020304, 0x00000000, 0xffffff, 0x10203040, 0x78971626, 0x66778811, 0x12131415};
unsigned int giMemTestActions[] = { 1, 1,1, 1,0,0,0,1,1,1,0 };
unsigned int giSelectedItem = 0;
unsigned int giMemSize = 0; // initialized by tfe_init

extern void tfe_init();
char gsLineNames[32][3] = {"0 ", "1 ", "2 ", "3 ", "4 ", "5 ", "6 ", "7 ", "8 ", "9 ", "10","11","12","13","14","15","16","17","18","19","20","21","22","23","24","25","26","27","28","29","30","31" };

void showMainMenu(unsigned int iSel)
  {
    int iW = 40;
    int iH = 10;
    int i,j, iItem = -1;
    giSelectedItem = iSel;
    // Darstellung unseres Menus //
    scDbg("\033[4;6H"); // cursor pos        y;x //
    scDbg("\033[46m");   // Hintergrund //
    for (i = 0; i < iH; i++)
      {
        char* pItem = gsMenuItems[i];
        scDbg("\033[46m");
        if (pItem)
          {
            iItem++;
            if (giSelectedItem == iItem)
              scDbg("\033[42m");

            scDbg("  (\033[30m"); // highlight for short keys //
            scDbgPrintChar(iItem+'1');
            scDbg("\033[37m) "); // normal

            scDbg(pItem); for (j=0; j < iW-strlen(pItem)-6; j++) scDbgPrintChar(' ');
          }
        else
          for (j=0; j < iW; j++)
            scDbgPrintChar(' ');
        scDbg("\n\033[5C");                // x-1 //
      }
  }

void hideActionFrame(const char* sText, char boError)
  {
    int iW = 70;
    int iH = 4;
    int i,j;
    scDbg("\033[18;6H"); // cursor pos        y;x //
    for (j=0; j<iW-strlen(sText);j++)
      scDbg("\033[1C");
    if (boError)
      scDbg("\033[41m");
    else
      scDbg("\033[43m");
    scDbg(sText);

    scDbgReadChar(0);

    // Darstellung eines Hintergrundes //
    scDbg("\033[18;6H"); // cursor pos        y;x //
    scDbg("\033[44m");   // Hintergrund //
    for (i = 0; i < iH; i++)
      {
        for (j=0; j < iW; j++)
          scDbgPrintChar(' ');
        scDbg("\n\033[5C");                // x-1 //
      }
  }

void showActionFrame(const char* sTitle)
  {
    int iW = 70;
    int iH = 4;
    int i,j;
    // Darstellung eines Fensters //
    scDbg("\033[18;6H"); // cursor pos        y;x //
    scDbg("\033[43m");   // Hintergrund //
    scDbg(sTitle);
    for (i=0;i<iW-strlen(sTitle);i++)
      scDbgPrintChar(' ');
    scDbg("\n\033[5C");

    scDbg("\033[40m");   // Hintergrund //
    for (i = 0; i < iH-1; i++)
      {
        for (j=0; j < iW; j++)
          scDbgPrintChar(' ');
        scDbg("\n\033[5C");                // x-1 //
      }
  }

void tfe_executeMemoryTest()
  {
    showActionFrame("-- Speichertest --");
    gsTerminalFrontEnd.miRegs[FE_REG_MEMTEST_PATTERN] = giMemTestPatterns[0];
    gsTerminalFrontEnd.miRegs[FE_REG_MEMTEST_KIND] = 0; // pattern test //
    if (gsTerminalFrontEnd.handleCmd(FE_CMD_EXECUTE_MEMORY_TEST))
      hideActionFrame(" [ Test erfolgreich ] ", 0);
    else
      hideActionFrame(" [ Test fehlerhaft ] ", 1);
  }

void tfe_executeMemoryTestIntensive()
  {
    int i;
    char boError = 0;
    showActionFrame("-- Speichertest (intensiv) --");
    for (i = 0; i < 12; i++)
      {
        gsTerminalFrontEnd.miRegs[FE_REG_MEMTEST_PATTERN] = giMemTestPatterns[i];
        gsTerminalFrontEnd.miRegs[FE_REG_MEMTEST_KIND] = giMemTestActions[i];
        if (!(gsTerminalFrontEnd.handleCmd(FE_CMD_EXECUTE_MEMORY_TEST)))
          {
            boError = (1==1);
            break;
          }
      }
    if (!boError)
      hideActionFrame(" [ Test erfolgreich ] ", 0);
    else
      hideActionFrame(" [ Test fehlerhaft ] ", 1);
  }

void tfe_executeDataLinesCheck()
  {
    int i;
    char boError = 0;
    showActionFrame("-- Speichertest with self refresh --");
    for (i = 0; i < 12; i++)
      {
        gsTerminalFrontEnd.miRegs[FE_REG_MEMTEST_PATTERN] = giMemTestPatterns[i];
        gsTerminalFrontEnd.miRegs[FE_REG_MEMTEST_KIND] = giMemTestActions[i];
        if (!(gsTerminalFrontEnd.handleCmd(FE_CMD_EXECUTE_MEMORY_TEST_SR)))
          {
            boError = (1==1);
            break;
          }
      }
    if (!boError)
      hideActionFrame(" [ Test erfolgreich ] ", 0);
    else
      hideActionFrame(" [ Test fehlerhaft ] ", 1);
  }

void tfe_executeIOTest()
  {
    volatile unsigned short* pShort = (short*)0x30000000;
    showActionFrame("-- NSCX - Test --");
    for (;;)
      {
        unsigned int i=0;
        unsigned short iRead = *pShort;
        scDbg("\033[20;8HRead: 0x"); scDbgPrintHex32(iRead);
        scDbg("\033[21;10H");
        for (i = 0; i < 16; i++)
          {
            if (iRead & (1 << i))
              {
                scDbg("D");
                scDbg(gsLineNames[i]);
                scDbg(" ");
              }
            else
              scDbg("    ");
          }
        if (scDbgHasChar())
          break;
      }
    hideActionFrame("Test beendet",0);
  }

void tfe_init(unsigned int iSDRAMSize)
  {
    int i;
    giMemSize = iSDRAMSize;
    scDbg("\033[47m\033[37m"ANSI_CLRSCREEN);
    scDbg("\033[46m"ANSI_ClEARLINE);
    scDbg(" - Der erste Kontakt"); for (i=0;i<40;i++) scDbgPrintChar(' '); scDbg("\033[34m(c) 2004 by Conitec\033[44m\n\033[37m");
    for (i=0;i<22;i++) scDbg(ANSI_ClEARLINE"\n");
    scDbg("\033[46m"ANSI_ClEARLINE); scDbg(" < Benutze Ziffern-Tasten und Return >");
    scDbg(" Memory: 0x"); scDbgPrintHex32(iSDRAMSize);

    gsTerminalFrontEnd.miRegs[FE_REG_MEMTEST_PATTERN] = giMemTestPatterns[0];
    gsTerminalFrontEnd.miRegs[FE_REG_MEMTEST_KIND] = 0; // pattern test //
    showMainMenu(giSelectedItem);
  }

void tfe_poll()
  {
    char c = scDbgReadChar(0);

    if ((c >= '1') & (c <= '9'))
      {
        showMainMenu(c-'1');
        c = '\n';
      }

    if ((c == '\r') || (c == '\n'))
      {
        switch (giSelectedItem)
          {
            case 0:
              tfe_executeMemoryTest();
             break;
            case 1:
              tfe_executeMemoryTestIntensive();
             break;
            case 2:
              tfe_executeDataLinesCheck();
             break;
            case 3:
              tfe_executeIOTest();
             break;
            case 4:
              tfe_init(giMemSize); // Neudarstellung //
             break;
          }
      }
    // ]
  }

void tfe_submitMemoryTestProgress(unsigned int iAddr, char boError, unsigned int iReadOut)
  {
    scDbg("\033[20;42HAddr: 0x");
    scDbgPrintHex32(iAddr);
    if (boError)
      {
        scDbg("\033[21;8HERROR! Ausgelesen: 0x");
        scDbgPrintHex32(iReadOut);
      };
  }

void tfe_submitMemoryTestPatternInit(unsigned int iPattern, unsigned int iAddr)
  {
    if (iAddr == 0xffffffff)
      {
        scDbg("\033[20;8HPattern: 0x"); scDbgPrintHex32(iPattern); scDbg("                            ");
      }
    else
      if (iAddr == 0xfffffffe)
        {
          scDbg("\033[20;8HLinear Pattern Test: 0x"); scDbgPrintHex32(iPattern); scDbg("                              ");
        }
      else
        {
          scDbg("\033[20;8HInit Pattern: 0x"); scDbgPrintHex32(iPattern); scDbg(" (0x"); scDbgPrintHex32(iAddr); scDbg(")...          ");
        }
  }


struct cFrontEnd* getTerminalFrontEnd()
  {
    gsTerminalFrontEnd.init = tfe_init;
    gsTerminalFrontEnd.poll = tfe_poll;
    gsTerminalFrontEnd.submitMemoryTestProgress = tfe_submitMemoryTestProgress;
    gsTerminalFrontEnd.submitMemoryTestPatternInit = tfe_submitMemoryTestPatternInit;
    return (&gsTerminalFrontEnd);
  }
