#include <sc/sc.h> // system core //
#include <sc/sc_config.h>
#include <sc/sys_core.h>

extern void AT91F_PIO_ClearOutput(AT91PS_PIO p, unsigned int i);
extern void AT91F_PIO_SetOutput(AT91PS_PIO p, unsigned int i);
extern void AT91F_PIO_CfgOutput(AT91PS_PIO p, unsigned int i);
extern unsigned int AT91F_PIO_GetInput(AT91PS_PIO pPio);

void ledSetSingle(unsigned int iIdx)
  {
    (iIdx == 0) ? (AT91F_PIO_ClearOutput(AT91C_BASE_PIOA, AT91C_PIO_PA18)) : (AT91F_PIO_SetOutput(AT91C_BASE_PIOA, AT91C_PIO_PA18));
    (iIdx == 1) ? (AT91F_PIO_ClearOutput(AT91C_BASE_PIOA, AT91C_PIO_PA26)) : (AT91F_PIO_SetOutput(AT91C_BASE_PIOA, AT91C_PIO_PA26));
    (iIdx == 2) ? (AT91F_PIO_ClearOutput(AT91C_BASE_PIOA, AT91C_PIO_PA25)) : (AT91F_PIO_SetOutput(AT91C_BASE_PIOA, AT91C_PIO_PA25));
    (iIdx == 3) ? (AT91F_PIO_ClearOutput(AT91C_BASE_PIOA, AT91C_PIO_PA21)) : (AT91F_PIO_SetOutput(AT91C_BASE_PIOA, AT91C_PIO_PA21));
  }

void ledInit(void)
  {
    AT91F_PIO_CfgOutput(AT91C_BASE_PIOA, AT91C_PIO_PA18); // U4 //
    AT91F_PIO_CfgOutput(AT91C_BASE_PIOA, AT91C_PIO_PA26); // U3 //
    AT91F_PIO_CfgOutput(AT91C_BASE_PIOA, AT91C_PIO_PA25); // U2 //
    AT91F_PIO_CfgOutput(AT91C_BASE_PIOA, AT91C_PIO_PA21); // U1 //
    // turn on U4 //
    ledSetSingle(0);
  }

void ledToggle(void)
  {
    // toggle U3 //
    if (AT91F_PIO_GetInput(AT91C_BASE_PIOA) & (AT91C_PIO_PA26))
    AT91F_PIO_ClearOutput(AT91C_BASE_PIOA, AT91C_PIO_PA26);
      else
    AT91F_PIO_SetOutput(AT91C_BASE_PIOA, AT91C_PIO_PA26);
  }
