#include <sc/sc.h> // system core //
#include <sc/sc_config.h>
#include <sc/sys_core.h>

extern void AT91F_PIO_ClearOutput(AT91PS_PIO p, unsigned int i);
extern void AT91F_PIO_SetOutput(AT91PS_PIO p, unsigned int i);
extern void AT91F_PIO_CfgOutput(AT91PS_PIO p, unsigned int i);
extern unsigned int AT91F_PIO_GetInput(AT91PS_PIO pPio);

void ledSetSingle(unsigned int iIdx)
  {
    (iIdx == 0) ? (AT91F_PIO_SetOutput(AT91C_BASE_PIOD, AT91C_PIO_PD23)) : (AT91F_PIO_ClearOutput(AT91C_BASE_PIOD, AT91C_PIO_PD23));
    (iIdx == 1) ? (AT91F_PIO_SetOutput(AT91C_BASE_PIOD, AT91C_PIO_PD20)) : (AT91F_PIO_ClearOutput(AT91C_BASE_PIOD, AT91C_PIO_PD20));
    (iIdx == 2) ? (AT91F_PIO_SetOutput(AT91C_BASE_PIOD, AT91C_PIO_PD25)) : (AT91F_PIO_ClearOutput(AT91C_BASE_PIOD, AT91C_PIO_PD25));
    (iIdx == 3) ? (AT91F_PIO_SetOutput(AT91C_BASE_PIOD, AT91C_PIO_PD22)) : (AT91F_PIO_ClearOutput(AT91C_BASE_PIOD, AT91C_PIO_PD22));
    (iIdx == 4) ? (AT91F_PIO_SetOutput(AT91C_BASE_PIOD, AT91C_PIO_PD21)) : (AT91F_PIO_ClearOutput(AT91C_BASE_PIOD, AT91C_PIO_PD21));
  }

void ledInit(void)
  {
    // initialize i/o ports //
    AT91F_PIO_CfgOutput(AT91C_BASE_PIOD, AT91C_PIO_PD23);
    AT91F_PIO_CfgOutput(AT91C_BASE_PIOD, AT91C_PIO_PD20);
    AT91F_PIO_CfgOutput(AT91C_BASE_PIOD, AT91C_PIO_PD25);
    AT91F_PIO_CfgOutput(AT91C_BASE_PIOD, AT91C_PIO_PD22);
    AT91F_PIO_CfgOutput(AT91C_BASE_PIOD, AT91C_PIO_PD21);
    // turn on U4 //
    ledSetSingle(0);
  }

void ledToggle(void)
  {
    // toggle U3 //
    if (AT91F_PIO_GetInput(AT91C_BASE_PIOD) & (AT91C_PIO_PD23))
      AT91F_PIO_ClearOutput(AT91C_BASE_PIOD, AT91C_PIO_PD23);
    else
      AT91F_PIO_SetOutput(AT91C_BASE_PIOD, AT91C_PIO_PD23);
  }
