#ifndef __sc_config_h
  #define __sc_config_h

/**
  This configuration file is for usage of conitec's ARM-Board.
*/


// Startadresse (virtuell) SDRAM
#define SC_SDRAM_BASE                        0x20000000

// UDP bus disconnection io
#define SC_IO_CONFIG_UDP_DISCONNECT_BUS      AT91C_PIO_PD9

// Boudrate fr den Debug-Port
#define SC_DBG_BAUD_RATE                     115200

// Einstellung der Schnittstellenparameter fr den Debug-Port
#define SC_DBG_DBG_ASYNC_MODE (AT91C_US_USMODE_NORMAL + AT91C_US_NBSTOP_1_BIT + AT91C_US_PAR_NONE + AT91C_US_CHRL_8_BITS + AT91C_US_CLKS_CLOCK)


#define SC_MAIN_CLOCK_DIV2                   0x102
#define SC_MAIN_CLOCK_DIV3                   0x202
#define SC_MAIN_CLOCK_DIV4                   0x302


/*
  The following configuration is for libscll. If you link this library the clocks will be configured.
  If you wan't to live with slower clocks you may use libscll-lc. This library configures a 20MHz CPU clock to save power.
*/

#if 1
  #define SC_PLLA_VALUE                        PLL_VALUE_FAST(8,72)   // 20MHz / 8 * 72   = 180 MHz
  #define SC_PLLB_VALUE                        PLLB_VALUE_USB(45,216) // 20MHz / 45 * 216 = 96MHz
  #define SC_MDIV3                             1 // BUS clock = MainClock / 3 //
#else
  #define SC_PLLA_VALUE                        PLL_VALUE_FAST(8,64)   // 160 MHz
  #define SC_PLLB_VALUE                        PLLB_VALUE_USB(45,216) // fr 20MHz quarz -> 96MHz //
  #define SC_MDIV2                             1 // the bus clock is main-clock / 2
#endif


#endif // __sc_config_h
