#include "asm-at91rm9200.h"

                .text
                .align

# We expect the size of memory installed in r0 and the address of __switch_cpu_clock in r1.
# By default we use the last address of memory installed as top of user stack. 
# So we simply add 0x20000000 to the size of memory and use the resulting value as TOS.
# The size of memory installed will also be passed as first argument to the main function.
# (Stack grows down to zero).

#define USER_STACK_START   0x21000000

startoftext:
        add r2, r0, #0x20000000
# Assure alignment (32-bit)
        bic     r2, r2, #3
        mov     sp, r2
 
        stmfd sp!, {r0,r1}
        bl sc_setup
        ldmfd sp!, {r0,r1}

# Enter crt0
        b _main

End:
        b           End
