/**
 * Copyright (c) 2005 Peer Georgi <peer@peer-ware.de>
 * License: GPL
 *
 * This program is free software; you may redistribute and/or modify it under
 * the terms of the GNU General Public License Version 2 as published by the
 * Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY, without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for complete details.
*/


#ifndef __sc_h
  #define __sc_h

#include <libsc/sys_debug.h>                  // debug messages //
#include <libsc/sys_int.h>                    // interrupt handing //
#include <libsc/sys_time.h>                   // basic timer handling //


typedef void (*tSwitchClocks)(unsigned int iPLLAConfig, unsigned int iPLLBConfig, unsigned int iMDIV, unsigned int iNewSDRAMSR);

/**
  \brief Start functions.

  main - function for SRAM located applications. (linked with core/asm/entry.S)
    void boot();

  main - function for SDRAM located applications. (linked with core/asm/entry-user.S)
    \li iSDRAMSize    - size of detected SDRAM in bytes.
    \li pSwitchClocks - points to a switchClock function located in SRAM. (Disable interrupts before calling!)
    void boot(unsigned int iSDRAMSize, tSwitchClocks pSwitchClocks);
*/

#endif // __sc_h
