/**
 * Copyright (c) 2005 Peer Georgi <peer@peer-ware.de>
 * License: GPL
 *
 * This program is free software; you may redistribute and/or modify it under
 * the terms of the GNU General Public License Version 2 as published by the
 * Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY, without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for complete details.
*/


#ifndef __sys_debug_h
  #define __sys_debug_h

extern void scDbg(const char*);
extern void scDbgPrintChar(char);
extern void scDbgPrintHex32(unsigned int);
extern void scDbgPrintHex8(unsigned char);
extern int scDbgReadChar(unsigned int i);
extern int scDbgHasChar();

/*
  Empfngt einen Datenblock der maximalen Groesse iMaxSize (vielfaches von 128) per XModem Protokoll.
  Rckgabewert:
    0 - Fehler (Keine Verbindung)
    1 - Ok
    2 - Zu viele Daten
    3 - Zu viele CheckSum Fehler (mehr als 5)
    iMaxSize = Anzahl der empfangenden Bytes.
*/
extern int scDbgXModemReceive(char* pTarget, unsigned int* iMaxSize, int iMaxTry, char* pTmp1024);

//extern void strncpy(void* pTo, const void* pFrom, unsigned int iCount);
//extern void* memcpy(void* pTo, const void* pFrom, unsigned int iCount);
extern void memset32(unsigned int* pTo, unsigned int i32, unsigned int iCount);
//extern void memset(void* pTo, char b, unsigned int iCount);
    
#endif // __sys_debug_h
