/**
 * Copyright (c) 2005 Peer Georgi <peer@peer-ware.de>
 * License: GPL
 *
 * This program is free software; you may redistribute and/or modify it under
 * the terms of the GNU General Public License Version 2 as published by the
 * Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY, without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for complete details.
*/


#include <at/include/at91rm9200-def.h>
#include "sys_int.h"
#include "sys_time.h"

extern void __sc_asm_cli(void);
extern void __sc_asm_sti(void);


/**
  Globaler Interrupt-Handler.
*/
void sc_handleInterrupts()
  {
    // system timer (32768-Hz based) //
    if (AT91C_BASE_ST->ST_SR & 0x01)
      sc_handleSTInterrupt();
  }

void sc_sti()
  {
    // allow interrupts //
    AT91C_BASE_AIC->AIC_IECR = 1 << AT91C_ID_SYS;
    __sc_asm_sti();
  }

void sc_cli()
  {
  // disable interrupts //
//    AT91F_AIC_DisableIt(AT91C_BASE_AIC, AT91C_ID_SYS);
    __sc_asm_cli();
  }

void sc_shutDown()
  {
    sc_cli();
  }
