/**
 * Copyright (c) 2005 Peer Georgi <peer@peer-ware.de>
 * License: GPL
 *
 * This program is free software; you may redistribute and/or modify it under
 * the terms of the GNU General Public License Version 2 as published by the
 * Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY, without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for complete details.
*/


#include "sys_time.h"

volatile unsigned int giTimerTicks = 0;
volatile unsigned int giWaitMS = 0;

unsigned int sc_getTickCount()
  {
    return (giTimerTicks);
  }

/**
  Wartet die bergebene Zeit in Millisekunden.
  Dabei wird einer Genauigkeit von nur 99.29% entsprochen.
  Maximale Wartezeit: 36 Stunden.
*/
void sc_waitTime(unsigned int iMS)
  {
    giWaitMS = iMS*33;
    while (giWaitMS);
  }

void sc_waitTicks(unsigned int i)
  {
    giWaitMS = i;
    while (giWaitMS);
  }


void sc_handleSTInterrupt()
  {
    giTimerTicks++;
    if (giWaitMS)
      giWaitMS--;
  }
