/**
 * Copyright (c) 2005, 2006 Peer Georgi <peer@peer-ware.de>
 * License: GPL
 *
 * This program is free software; you may redistribute and/or modify it under
 * the terms of the GNU General Public License Version 2 as published by the
 * Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY, without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for complete details.
*/


#include <sys_core.h>
#include <sc_config.h>
#include <libsc/sys_core.h>
#include <asm/mcu-direct.h>
#include "scll.h"
// do not initialize systemclock...
//#define SC_CLOCK_SUPPRESS_CONFIGURATION

/*
  This low level initialization scheme does not setup high mcu clocks.
  It uses the (rom-firmware) preconfigured 48MHz mcu clock, initializes
  the SDRAM, timer and debug port and continues.

  You may use this scheme on USB powered devices to keep the current draw
  below 100mA while startup.
*/

extern void __setup_cpu_clock(unsigned int iPLLAConfig, unsigned int iPLLBConfig, unsigned int iMDIV);



#if 0
#include "sdram-regs.h"
void sc_setup_eb(void)
  {
    // sc_cli(); // interrupts are disabled by default //
    // Init Interrupt Controller
    scInitAIC();
    scInitDBGU(48000000);

    // Setup Interrupts //
    scInitTimer();

    __setup_cpu_clock(PLLA_VALUE_FAST(4,39), PLLB_VALUE_USB(24,125), SC_MAIN_CLOCK_DIV3);
    scInitDBGU(59904000);

    // The low level counterpart of user software. (Runs with 48MHz.)
    scInitStage0();

    // try setup sdram after starting clocks...
//    scProbeSDRAM(66638760);

    // force evalboard eb90 //
    scInitSDRAM(59904000, SC_SDRAM_SETUP(SC_SDRAM_COL_BITS_9, SC_SDRAM_ROW_BITS_12, SC_SDRAM_NUM_BANKS_4, 2, 8, 3, 3, 3, 4), 1);
    scSetSDRAMSize(16*1024*1024);
  }
#endif

/*
  \brief sc_setup will be called by entry.S to initialize the system.
  The following functions must be defined by user:
    void scInitStage0(void) - interrupt controller is initialized
    void scInitStage1(void) - clock has been initialized
    void scInitStage2(void) - external sdram has been initialized
*/
void sc_setup_carmeva(void)
  {
    // sc_cli(); // interrupts are disabled by default //
    // Init Interrupt Controller
    scInitAIC();
    scInitDBGU(48000000);

    // Setup Interrupts //
    scInitTimer();

#ifdef MCK80
    __setup_cpu_clock(PLLA_VALUE_FAST(8,64), PLLB_VALUE_USB(45,216), SC_MAIN_CLOCK_DIV2);
    scInitDBGU(80000000);

    // The low level counterpart of user software. (Runs with 48MHz.)
    scInitStage0();

    // try setup sdram after starting clocks...
    scProbeSDRAM(80000000);
#else
    __setup_cpu_clock(PLLA_VALUE_FAST(8,72), PLLB_VALUE_USB(45,216), SC_MAIN_CLOCK_DIV3);
    scInitDBGU(60000000);

    // The low level counterpart of user software. (Runs with 48MHz.)
    scInitStage0();

    // try setup sdram after starting clocks...
    scProbeSDRAM(60000000);
#endif


#if 0
//     // sc_cli(); // interrupts are disabled by default //
//     // Init Interrupt Controller
//     scInitAIC();
//     scInitDBGU(48000000);
//
//     // Setup Interrupts //
//     scInitTimer();
//
//     // The low level counterpart of user software. (Runs with 48MHz.)
//     scInitStage0();
//
//     // Debug...
// //    AT91F_PIO_CfgOutput(AT91C_BASE_PIOD, AT91C_PIO_PA23);
// //    AT91F_PIO_SetOutput(AT91C_BASE_PIOD, AT91C_PIO_PA23);
//
// #ifndef SC_CLOCK_SUPPRESS_CONFIGURATION
//     __setup_cpu_clk();
// #else
//   #warning Suppressing clock configuration!
// #endif
//
//     // Init Debug Port
//     scInitDBGU(SC_MASTER_CLOCK);
//
//     // try setup sdram after starting clocks...
//     scProbeSDRAM(SC_MASTER_CLOCK);
//
// //    AT91F_PIO_SetOutput(AT91C_BASE_PIOA, AT91C_PIO_PA21);
#endif
  }



/*
  \brief sc_setup will be called by entry.S to initialize the system.
  The following functions must be defined by user:
    void scInitStage0(void) - interrupt controller is initialized
    void scInitStage1(void) - clock has been initialized
    void scInitStage2(void) - external sdram has been initialized
*/
void sc_setup(void)
  {
    sc_setup_carmeva();
  }
