/**
 * Copyright (c) 2005 Peer Georgi <peer@peer-ware.de>
 * License: GPL
 *
 * This program is free software; you may redistribute and/or modify it under
 * the terms of the GNU General Public License Version 2 as published by the
 * Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY, without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for complete details.
*/


#include "string.h"

int strncmp(const char * cs,const char * ct,size_t count)
  {
    register signed char __res = 0;

    while (count)
      {
        if ((__res = *cs - *ct++) != 0 || !*cs++)
          break;
        count--;
      }
    return __res;
  }

  void* memcpy(void * dest,const void *src, unsigned int count)
    {
    char *tmp = (char*)dest, *s = (char*)src;
      while (count--)
        *tmp++ = *s++;
      return dest;
    }

  int memcmp(const void * cs,const void * ct, unsigned int count)
    {
      int res = 0;
      const unsigned char* su1 = (unsigned char*)cs;
      const unsigned char* su2 = (unsigned char*)ct;
      for (; 0 < count; ++su1, ++su2, count--)
        if ((res = *su1 - *su2) != 0)
          break;
      return res;
    }

  char* strrchr(const char * s, int c)
    {
      const char *p = s + strlen(s);
      do
        {
          if (*p == (char)c)
            return (char *)p;
        } while (--p >= s);
      return 0;
    }

  unsigned int strlen(const char * s)
    {
      const char* sc;
      for (sc = s; *sc != '\0'; ++sc)
        ;;
      return sc - s;
    }

  char* strstr(const char* s1, const char* s2)
    {
      int l2 = strlen(s2);
      int l1 = strlen(s1);
      if (!l2)
        return (char *) s1;
      while (l1 >= l2)
        {
          l1--;
          if (!memcmp(s1,s2,l2))
            return (char *) s1;
          s1++;
        }
      return 0;
    }
    
  char* strncpy(char * dest,const char *src, unsigned int count)
    {
      char *tmp = dest;
      while (count-- && (*dest++ = *src++) != '\0')
        ;;
      return tmp;
    }

void* memset(void* pDest, int iPattern, size_t iSize)
  {
    unsigned char* p = (unsigned char*)pDest;
    while (iSize--)
      *p++ = iPattern;
    return (pDest);
  }
