#ifndef __carmeva_uc1611_h
  #define __carmeva_uc1611_h

struct tCArmEvaLCD
  {
    unsigned int mboMirrorX;  /* (1==1) on mirror x enabled */
    unsigned int mboMirrorY;  /* (1==1) on mirror y enabled */
    unsigned char* mpIO;      /* io mapped area */
    unsigned char* mpFB;      /* Offscreen buffer */

    const char* mpFont;
    unsigned int miFontMax;
    unsigned int miCharWidth;
    unsigned int miCharHeight;

    void __iomem* mpTCBBase;
  };

#define TRUE   (1 == 1)
#define FALSE  (!TRUE)
#define bool   unsigned int


void carmeva_lcd_setup(struct tCArmEvaLCD* p);
unsigned int carmeva_lcd_detect(struct tCArmEvaLCD* p);
void carmeva_lcd_clear(struct tCArmEvaLCD* p);
void carmeva_lcd_setPixel(struct tCArmEvaLCD* p, unsigned int iX, unsigned int iY, char bCol);
unsigned int getCharLine(struct tCArmEvaLCD* p, int iAscii, unsigned int iLine);
void carmeva_lcd_putChar(struct tCArmEvaLCD* p, unsigned int iX, unsigned int iY, char iAscii, unsigned int boTransp, char bCol, char bBackground);
void carmeva_lcd_putString(struct tCArmEvaLCD* p, unsigned int iX, unsigned int iY, const char* sText, unsigned int iCount, unsigned int boTransp, char bCol, char bBackground);
void carmeva_lcd_putAttrString(struct tCArmEvaLCD* p, unsigned int iX, unsigned int iY, const unsigned short* sText, unsigned int iCount, unsigned int boTransp, char bCol, char bBackground);
void carmeva_lcd_repaintAll(struct tCArmEvaLCD* p);
void carmeva_lcd_set_contrast(struct tCArmEvaLCD* p, unsigned int b);
void carmeva_lcd_set_backlight(struct tCArmEvaLCD* p, unsigned int b);
bool drawPNM(struct tCArmEvaLCD* pDisplay, unsigned int iX, unsigned int iY, const char* pPNMAddr, unsigned int iSize);


// #define __CARMEVA_LCD_DEBUG

#endif // __carmeva_uc1611_h
