#!/bin/sh
clear

IMAGE_NAME=rootfs.image

echo -n "Size of Image (kB) (12288 should be enough): "
read value_imagesize
if [ "$value_imagesize" = "" ]; then
  echo "Assuming 1024kB as default size."
  value_imagesize=1024
fi

echo -n "Creating image of size ""$value_imagesize""kb"
dd if=/dev/zero of=$IMAGE_NAME bs=1024 count="$value_imagesize" 1> /dev/null 2> /dev/null
if [ -e $IMAGE_NAME ]; then
  echo " - success"
else
  echo " - failed."
  exit
fi


echo -n "Do you wan't to create a file system (ext2) ? (Y/n): "
read yesno_createfs
if [ "$yesno_createfs" = "" ]; then
  yesno_createfs="Y"
fi
if [ "$yesno_createfs" = "Y" ]; then
  echo -n "Creating file system... " $IMAGE_NAME
  
  /sbin/mkfs.ext2 $IMAGE_NAME
fi
