#!/bin/sh

ERROR_LOG=/dev/null

doFixup()
{
echo -e "Rootfs fixup...\t"
while [ ! -z $1 ]; do
  TYPE=$1
  shift
  SRC=$1
  shift
  DST=$1
  shift
  if [ ! -e $SRC ]; then
    echo "Source file ($SRC) does no exist!" > $ERROR_LOG
  else
    if [ "$TYPE" = "C" ]; then
      echo -en "  * Copy [$SRC -> $DST] "
      if ! cp $SRC $DST 2>>$ERROR_LOG; then
        echo "[failed]"
      else
        echo "[done]"
      fi
    fi 
    if [ "$TYPE" = "L" ]; then
      echo -en "  * Link [$SRC -> $DST] "
      if ! ln -sf $SRC $DST 2>>$ERROR_LOG; then
        echo "[failed]"
      else
        echo "[done]"
      fi
    fi
  fi
done
}


doFixup `cat fixup`
