#!/bin/sh

# links application and libraries...

# We need:
#  CFG_PATH
#  INITD_PATH
#  BOOT_ERR_LOG

check()
{
  if [ -z "$1" ]; then
    echo "Plase don't start this script manualy!"
    if [ ! -z "$2" ]; then
      echo "$2 is not defined!"
    fi
    exit 1
  fi
}

check $CFG_PATH CFG_PATH
check $INITD_PATH INITD_PATH
check $BOOT_ERR_LOG BOOT_ERR_LOG


#
# Welcome
#
if [ -e $CFG_PATH/product ]; then
  PRODUCT=`cat $CFG_PATH/product`
fi

if [ -z $PRODUCT ]; then
  PRODUCT=default
fi

echo
echo "$INITD_PATH/rcInit:"
echo -e "Productinfo: \t\t\t\t["$PRODUCT"]"

if [ -e /app/fixup/do-fixup.sh ]; then
  echo "Final rootfs fixup\t\t"
  cd /app/fixup && ./do-fixup.sh
  cd $INITD_PATH
fi


echo -en "Checking serial\t\t\t\t"
SERIAL=`dfConfig -rs serial 2>> $BOOT_ERR_LOG`
# Copy the serial number to it's final place.
if [ ! -z "$SERIAL" ]; then
  echo "[$SERIAL]"
else
  echo "[error - may cause problems later]"
fi

echo -en "Setting up hostname...\t\t\t"
hostname "$PRODUCT-$SERIAL" 2>>$BOOT_ERR_LOG
echo "[`hostname`]"


# Device specific steps...
echo -en "Release check\t\t\t\t"

#
# Basic checks
#
if [ ! -e /app/sw/bin ]; then
  echo "- Missing device specific software!"
else
  echo "[done]"
fi


export SERIAL
export PRODUCT
